# GstGLBaseFilter

GstGLBaseFilter handles the nitty gritty details of retrieving an OpenGL context. It also provided some wrappers around GstBaseTransform's `start()`, `stop()` and `set_caps()` virtual methods that ensure an OpenGL context is available and current in the calling thread.

## GstGLBaseFilter

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstBaseTransform
                        ╰──GstGLBaseFilter
                            ╰──GstGLFilter

The parent instance type of a base GStreamer GL Filter.

### Members

`parent` (GstBaseTransform) –
No description available
`display` (GstGLDisplay *) –

the currently configured GstGLDisplay

`context` (GstGLContext *) –

the currently configured GstGLContext

`in_caps` (GstCaps *) –

the currently configured input GstCaps

`out_caps` (GstCaps *) –

the currently configured output GstCaps

### Class structure

#### GstGLBaseFilterClass

The base class for GStreamer GL Filter.

##### Fields

`parent_class` (GstBaseTransformClass) –
No description available
`supported_gl_api` (GstGLAPI) –

the logical-OR of GstGLAPI's supported by this element

### GstGL.GLBaseFilterClass

The base class for GStreamer GL Filter.

##### Attributes

`parent_class` (GstBase.BaseTransformClass) –
No description available
`supported_gl_api` (GstGL.GLAPI) –

the logical-OR of GstGL.GLAPI's supported by this element

### GstGL.GLBaseFilterClass

The base class for GStreamer GL Filter.

##### Attributes

`parent_class` (GstBase.BaseTransformClass) –
No description available
`supported_gl_api` (GstGL.GLAPI) –

the logical-OR of GstGL.GLAPI's supported by this element

## GstGL.GLBaseFilter

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.Element
                    ╰──GstBase.BaseTransform
                        ╰──GstGL.GLBaseFilter
                            ╰──GstGL.GLFilter

The parent instance type of a base GStreamer GL Filter.

### Members

`parent` (GstBase.BaseTransform) –
No description available
`display` (GstGL.GLDisplay) –

the currently configured GstGL.GLDisplay

`context` (GstGL.GLContext) –

the currently configured GstGL.GLContext

`in_caps` (Gst.Caps) –

the currently configured input Gst.Caps

`out_caps` (Gst.Caps) –

the currently configured output Gst.Caps

## GstGL.GLBaseFilter

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.Element
                    ╰──GstBase.BaseTransform
                        ╰──GstGL.GLBaseFilter
                            ╰──GstGL.GLFilter

The parent instance type of a base GStreamer GL Filter.

### Members

`parent` (GstBase.BaseTransform) –
No description available
`display` (GstGL.GLDisplay) –

the currently configured GstGL.GLDisplay

`context` (GstGL.GLContext) –

the currently configured GstGL.GLContext

`in_caps` (Gst.Caps) –

the currently configured input Gst.Caps

`out_caps` (Gst.Caps) –

the currently configured output Gst.Caps

### Methods

#### gst_gl_base_filter_find_gl_context

    gboolean
    gst_gl_base_filter_find_gl_context (GstGLBaseFilter * filter)

Parameters:

`filter` –

a GstGLBaseFilter

Returns –

Whether an OpenGL context could be retrieved or created successfully

Since : 1.16

#### GstGL.GLBaseFilter.prototype.find_gl_context

    function GstGL.GLBaseFilter.prototype.find_gl_context(): {
        // javascript wrapper for 'gst_gl_base_filter_find_gl_context'
    }

Parameters:

`filter` (GstGL.GLBaseFilter) –

a GstGL.GLBaseFilter

Returns (Number) –

Whether an OpenGL context could be retrieved or created successfully

Since : 1.16

#### GstGL.GLBaseFilter.find_gl_context

    def GstGL.GLBaseFilter.find_gl_context (self):
        #python wrapper for 'gst_gl_base_filter_find_gl_context'

Parameters:

`filter` (GstGL.GLBaseFilter) –

a GstGL.GLBaseFilter

Returns (bool) –

Whether an OpenGL context could be retrieved or created successfully

Since : 1.16

#### gst_gl_base_filter_get_gl_context

    GstGLContext *
    gst_gl_base_filter_get_gl_context (GstGLBaseFilter * filter)

Parameters:

`filter` –

a GstGLBaseFilter

Returns ( [transfer: full][nullable]) –

the GstGLContext found by filter

Since : 1.18

#### GstGL.GLBaseFilter.prototype.get_gl_context

    function GstGL.GLBaseFilter.prototype.get_gl_context(): {
        // javascript wrapper for 'gst_gl_base_filter_get_gl_context'
    }

Parameters:

`filter` (GstGL.GLBaseFilter) –

a GstGL.GLBaseFilter

Returns (GstGL.GLContext) –

the GstGL.GLContext found by filter

Since : 1.18

#### GstGL.GLBaseFilter.get_gl_context

    def GstGL.GLBaseFilter.get_gl_context (self):
        #python wrapper for 'gst_gl_base_filter_get_gl_context'

Parameters:

`filter` (GstGL.GLBaseFilter) –

a GstGL.GLBaseFilter

Returns (GstGL.GLContext) –

the GstGL.GLContext found by filter

Since : 1.18

### Properties

#### context

    “context” GstGLContext *

Flags : Read

#### context

    “context” GstGL.GLContext

Flags : Read

#### context

    “self.props.context” GstGL.GLContext

Flags : Read

### Virtual Methods

#### gl_set_caps

    gboolean
    gl_set_caps (GstGLBaseFilter * filter,
                 GstCaps * incaps,
                 GstCaps * outcaps)

called in the GL thread when caps are set on filter. Note: this will also be called when changing OpenGL contexts where GstBaseTransform::set_caps may not.

Parameters:

`filter` –
No description available
`incaps` –
No description available
`outcaps` –
No description available
Returns –
No description available

#### vfunc_gl_set_caps

    function vfunc_gl_set_caps(filter: GstGL.GLBaseFilter, incaps: Gst.Caps, outcaps: Gst.Caps): {
        // javascript implementation of the 'gl_set_caps' virtual method
    }

called in the GL thread when caps are set on filter. Note: this will also be called when changing OpenGL contexts where GstBaseTransform::set_caps may not.

Parameters:

`filter` (GstGL.GLBaseFilter) –
No description available
`incaps` (Gst.Caps) –
No description available
`outcaps` (Gst.Caps) –
No description available
Returns (Number) –
No description available

#### do_gl_set_caps

    def do_gl_set_caps (filter, incaps, outcaps):
        #python implementation of the 'gl_set_caps' virtual method

called in the GL thread when caps are set on filter. Note: this will also be called when changing OpenGL contexts where GstBaseTransform::set_caps may not.

Parameters:

`filter` (GstGL.GLBaseFilter) –
No description available
`incaps` (Gst.Caps) –
No description available
`outcaps` (Gst.Caps) –
No description available
Returns (bool) –
No description available

#### gl_start

    gboolean
    gl_start (GstGLBaseFilter * filter)

called in the GL thread to setup the element GL state.

Parameters:

`filter` –
No description available
Returns –
No description available

#### vfunc_gl_start

    function vfunc_gl_start(filter: GstGL.GLBaseFilter): {
        // javascript implementation of the 'gl_start' virtual method
    }

called in the GL thread to setup the element GL state.

Parameters:

`filter` (GstGL.GLBaseFilter) –
No description available
Returns (Number) –
No description available

#### do_gl_start

    def do_gl_start (filter):
        #python implementation of the 'gl_start' virtual method

called in the GL thread to setup the element GL state.

Parameters:

`filter` (GstGL.GLBaseFilter) –
No description available
Returns (bool) –
No description available

#### gl_stop

    gl_stop (GstGLBaseFilter * filter)

called in the GL thread to setup the element GL state.

Parameters:

`filter` –
No description available

#### vfunc_gl_stop

    function vfunc_gl_stop(filter: GstGL.GLBaseFilter): {
        // javascript implementation of the 'gl_stop' virtual method
    }

called in the GL thread to setup the element GL state.

Parameters:

`filter` (GstGL.GLBaseFilter) –
No description available

#### do_gl_stop

    def do_gl_stop (filter):
        #python implementation of the 'gl_stop' virtual method

called in the GL thread to setup the element GL state.

Parameters:

`filter` (GstGL.GLBaseFilter) –
No description available

The results of the search are